%>  *********************************************************************** 
%>   Copyright © 2017-2021 ETH Zurich, Andreas P. Cuny, Tomas Kuendig, 
%>   Aaron Ponti, Joerg Stelling; D-BSSE; CSB Group 
%>   All rights reserved. This program and the accompanying materials 
%>   are made available under the terms of the BSD-3 Clause License 
%>   which accompanies this distribution, and is available at 
%>   https://gitlab.com/csb.ethz/tracx/-/blob/master/LICENSE.rst 
%>    
%>  ***********************************************************************
function [  ] = evaluateFingerprint( this, lowerQuantile )
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here
% Idea for randomization: We randomize x percent of all linkages by
% permuting the track indicies and compare it against a ground truth.
% We test the fingerprinting method how well the failures are detected with
% (i) at all (should have ~x percent + noise above delta dist threshold and
% (ii) different parameter settings which gives best threshold for the
% cathegorization.
% 1. Track dataset
% 2. Check result manually and create ground truth from the results.
% 3. Permute i.e 10 percent of the linkages (trackindex)
% 4. Define parameter range for window, resizing and fingerprint frequencies.
% 5. All possible combinations for the parameter for a condition to test.
% 6. For each condition recompute fingerprints on all frames
% 7. Compute fingerprint distances on all frames
% 8. Do ground truth mapping
% 9. Compute delta distances for all linkages
% 10. Compute FPdist threshold based on delta dists
% 11. Do error cathegorization based on 8. and 10. -> results in 1 point on
%     the ROC curve corresponding to 1 condition (set of parameters)
% (Note) Could be that all points overlap and we do not get a 'curve'
% (Note2) What are we testing? If we compute FPdist dynamically as above
% not really the fingerprint performance more how well we can set a thrshold.
% Do we want this? If we keep the FPdist fixed, how
% well we cathegorize for a certain random threshold -> 1 ROC curve but arbitrary threshold. If we
% scan over a range of different FPdist thrsholds -> as many ROC curves as
% thrsholds tested -> hard to summarize visually.

%> @todo make this an argument.
pathToGroundTruth = fullfile(this.configuration.ProjectConfiguration. ...
    segmentationResultDir, 'GroundTruth\GroundTruth.csv');
evaluationResultsDir = fullfile(this.configuration.ProjectConfiguration. ...
    segmentationResultDir, 'EvaluationsNew');

fprintf('Result dir: %s \n', evaluationResultsDir)
fprintf('--------------------------------------------------------------- \n')

if ~exist(evaluationResultsDir, 'dir')
    mkdir(evaluationResultsDir)
end

% Definition of test cases
% testCases.case = [20, 30, 40, 50, 60; ...
%     4, 8,  12, 16, 20; ...
%     20, 25, 32, 40, 121];
testCases.case = [20, 30, 40, 50, 60, 80, 100, 120, 150, 200, 300; ...
    2, 4, 8, 10, 12, 16, 20, 25, 30, 35, 40; ...
    20, 25, 32, 40, 50, 64, 80, 121, 150, 200, 300]; % 15, 20, 25, 35, 40, 50, 60;
% winSize, freq, resizeing
% testCases.case = [20:1:60; ...
%     2:1:42; ...
%     40:2:121];
%testCases.case = [300; 16; 20];

% Create all possible combinations of the test cases.
casesAllCombinations = combvec(testCases.case(1,:), testCases.case(2,:), ...
    testCases.case(3,:));
invalidCombinations = casesAllCombinations(3,:) < casesAllCombinations(2,:);
casesAllCombinations = casesAllCombinations(:, ~invalidCombinations);

avgCellDiameter = mean(this.data.getFieldArray('cell_majoraxis'));
avgCellArea = mean(this.data.getFieldArray('cell_area'));
tic;
this.utils.printToConsole('')
% caseFPData = cell(numel(casesAllCombinations(1,:)), 1);
nCase = numel(casesAllCombinations(1,:));
pBar = this.utils.progressBar(nCase, ...
    'Title', 'Evaluation: Fingerprint evaluation' ...
    );
for iCase = 1:nCase %numel(casesAllCombinations(1,:))
    
    windowToTest = casesAllCombinations(1, iCase);
    freqToTest = casesAllCombinations(2, iCase);
    resizingToTest = casesAllCombinations(3, iCase);
    %sprintf("%d %d %d", windowToTest, freqToTest, resizingToTest)
    
    fpData = struct();
    % Re-compute fingerprint distances for each condition on all frames
    for frameNumber = this.configuration.ProjectConfiguration. ...
            trackerStartFrame : this.configuration.ProjectConfiguration. ...
            trackerEndFrame
        
        % Recompute fingerprints for various parameter values for window,
        % resizing and fingerprint frequencies on
        % Compute fingerprints (real freq) for current
        % image frame
        [ret_fq] = this.fingerprint.computeFingerprintForFrame(frameNumber, ...
            frameNumber,  windowToTest, resizingToTest, freqToTest, ...
            this.configuration.ProjectConfiguration.imageDir, ...
            this.configuration.ProjectConfiguration.imageFingerprintFileArray, ...
            this.configuration.ProjectConfiguration.imageCropCoordinateArray, ...
            this.data.SegmentationData.cell_frame, ...
            this.data.SegmentationData.cell_center_x, ...
            this.data.SegmentationData.cell_center_y);
        % Save fingerprints for current image frame
        this.data.setFieldArrayForFrame('track_fingerprint_real', ...
            frameNumber, ret_fq);
        
        if frameNumber > 1
            % Recompute fingerprint distances
            oldFrame.track_index = this.data.getFieldArrayForFrame( ...
                'track_index', frameNumber-1);
            oldFrame.track_fingerprint_real = this.data.getFieldArrayForFrame( ...
                'track_fingerprint_real', frameNumber-1);
            xO = this.data.getFieldArrayForFrame( 'cell_center_x', frameNumber-1);
            xOF = this.data.getFieldArrayForFrame( 'cell_filtered_dif_x', frameNumber-1);
            yO = this.data.getFieldArrayForFrame( 'cell_center_y', frameNumber-1);
            yOF = this.data.getFieldArrayForFrame( 'cell_filtered_dif_y', frameNumber-1);
                        
            newFrame.track_fingerprint_real = this.data.getFieldArrayForFrame( ...
                'track_fingerprint_real', frameNumber);
            newFrame.track_index = this.data.getFieldArrayForFrame( ...
                'track_index', frameNumber);
            xN = this.data.getFieldArrayForFrame('cell_center_x', frameNumber);
            yN = this.data.getFieldArrayForFrame('cell_center_y', frameNumber);
            
            [realFingerprintTrackDistance] = ...
                this.fingerprint.computeAssignmentFingerprintDistanceArray(...
                oldFrame, newFrame);
            
            this.data.setFieldArrayForFrame('track_fingerprint_real_distance', ...
                frameNumber-1, realFingerprintTrackDistance);
            
            % Get the cell region fingerprints for frameNumber
            crfO = this.data.getFieldArrayForFrame(...
                'track_fingerprint_real', frameNumber-1);
            crfN = this.data.getFieldArrayForFrame(...
                'track_fingerprint_real', frameNumber);
            % dCRF for assigned tracks on frame frameNumber
            dCRFAsgmt = this.data.getFieldArrayForFrame(...
                'track_fingerprint_real_distance', ...
                frameNumber-1);
            
            
            [dCRFM] = this.fingerprint.computeFingerprintDistance(crfO, crfN);
            % Neighbourhood indices as matrix for frameNumber
            %             [nhbrhdM, ~] = this.data.getMotionCorrNeighbours(...
            %                 frameNumber, this.configuration. ...
            %                 ParameterConfiguration.neighbourhoodSearchRadius);
            [joinedNeighbours, joinedNeighboursWMotion, ...
                    oldNeighbours, newNeighbours] = ...
                    this.data.getConsecutiveCloseCellNeighbourIdx(...
                    xO, xOF, yO, yOF, oldFrame.track_index, xN, yN, ...
                    newFrame.track_index, this.configuration. ...
                    ParameterConfiguration.neighbourhoodSearchRadius);
            [FFPa, ~, ~, ~, ~, ~] = this.fingerprint. ...
                computeFingerprintAsgmtFrac(crfO, crfN, dCRFAsgmt, ...
                joinedNeighboursWMotion);
            this.data.setFieldArrayForFrame(...
                'track_assignment_fraction', frameNumber-1, FFPa);
            
            fpData(frameNumber).dCRFAsgmt = dCRFAsgmt;
            fpData(frameNumber).dCRFM = dCRFM;
            fpData(frameNumber).nhbrhdM = joinedNeighboursWMotion;
            fpData(frameNumber).FFPa = FFPa;
            
        end
    end
    
    % Compute delta distances
    [this.deltaDistance, this.deltaDistanceNeighbours, this.fingerprintDistance, ...
        this.fingerprintDistanceNeighboursSize, this.deltaDistanceLowestNeighbour, ...
        this.deltaDistance2ndLowest, this.deltaDistance2ndLowestNeighbour]...
        = this.fingerprint.computeDeltaDistance(this.data, ...
        this.configuration.ProjectConfiguration. ...
        trackerStartFrame, this.configuration. ...
        ProjectConfiguration.trackerEndFrame);
    
    % Commpute predicted fingerprint distance threshold based on lower
    % quantile of negative delta distances.
    [fpDistTOld, fpDistThresholdPred] = this.fingerprint.computeFPDistThreshold( ...
        this.fingerprintDistance, this.fingerprintDistanceNeighboursSize, ...
        this.deltaDistance, this.deltaDistanceNeighbours, lowerQuantile);
    
    % Map test data to ground truth data
    [ ~ ] = this.mapTestDataToGroundTruth(...
        pathToGroundTruth, 0);
    
    % Cathegorize mapping results: the header is condition, replicate,
    % TP, TN, FP, FN
    %  Error matrix. FP (corr assign, above FP dist) == 1
    %                TN (corr assign, below FP dist) == 2
    %                FN (incorr assign, below FP dist) == 3
    %                TP (incorr assign, above FP dist) == 4
    errorCategorisation = this.createErrorMatrix(...
        'fpDistLUTTS', fpDistThresholdPred);
    
    %     [~,evalSummary] = this.evaluateTrackingResultProb(...
    %         evaluationResultsDir, 2, 0.1, iCase);
    testSetToEvaluate = this.configuration.ProjectConfiguration.projectName;
    permutationPercentage = 2;
    FPassigned = this.data.getFieldArray('track_fingerprint_real_distance');
    FFP = this.data.getFieldArray('track_fingerprint_real_distance');
    [ evalSummary ] = this.evaluateTrackingResultProb(FPassigned, ...
        FFP, permutationPercentage, evaluationResultsDir, testSetToEvaluate);
    
    % Save the evaluation results
    header = {'testCaseLabel',  'Case', 'avgCellDiameter', 'avgCellArea', ...
        'windowVariation', 'freqVariation', 'resizingVariation', ...
        'lowerQuantile', 'thresholdPred', 'FP', 'TN', 'FN', 'TP', 'optTau', ...
        'TPR', 'PPV', 'F_Score' ...
        'optTauNorm', 'TPRNorm', 'PPVNorm', 'F_ScoreNorm', ...
        'optTauFrac', 'TPRFrac', 'PPVFrac', 'F_ScoreFrac'};
    evalRunData = {this.configuration.ProjectConfiguration.projectName, ...
        iCase,  avgCellDiameter, avgCellArea, windowToTest, freqToTest, ...
        resizingToTest, lowerQuantile, fpDistThresholdPred, ...
        errorCategorisation(1), errorCategorisation(2), errorCategorisation(3), ...
        errorCategorisation(4), evalSummary.Parameter(1), evalSummary.TPR(1), ...
        evalSummary.PPV(1), evalSummary.F_Score(1)...
        evalSummary.Parameter(2), evalSummary.TPR(2), ...
        evalSummary.PPV(2), evalSummary.F_Score(2)...
        evalSummary.Parameter(3), evalSummary.TPR(3), ...
        evalSummary.PPV(3), evalSummary.F_Score(3)};
    
    evalSummaryTable = cell2table(evalRunData);
    evalSummaryTable.Properties.VariableNames = header;
    
%     this.io.writeToXLS(evalSummaryTable, evaluationResultsDir, ...
%         sprintf('Fingerprint_EvaluationSummary_%s_case_%d.xls', ...
%         this.configuration.ProjectConfiguration.projectName, iCase), ...
%         'rangeStartRow', iCase)
    
    if iCase == 1
        this.io.writeToXLS(evalSummaryTable, evaluationResultsDir, ...
            sprintf('Fingerprint_EvaluationSummary_%s.xls', ...
            this.configuration.ProjectConfiguration.projectName), ...
            'rangeStartRow', iCase)
    else
        this.io.writeToXLS(evalSummaryTable, evaluationResultsDir, ...
            sprintf('Fingerprint_EvaluationSummary_%s.xls', ...
            this.configuration.ProjectConfiguration.projectName), ...
            'rangeStartRow', iCase + 1, ...
            'writeVariableNames', false)
    end
    
    this.utils.printTimeLeft('Fingerprint evaluation:', iCase, ...
        numel(casesAllCombinations(1,:)))
    
    save(fullfile(evaluationResultsDir, ...
        sprintf('fpEvalCaseData_case_%d.mat', iCase)), 'fpData', '-v7.3')
   
    % Memory intensive
    % caseFPData{iCase} = fpData;
    
    pBar.step([], [], []);
end
pBar.release();

% Memory intensive
% save(fullfile(evaluationResultsDir, 'fpEvalCaseData.mat'), 'caseFPData', '-v7.3')

end
